diff --git a/usr/src/uts/common/io/cxgbe/t4nex/t4_sge.c b/usr/src/uts/common/io/cxgbe/t4nex/t4_sge.c
index 06d0e3f6d5..0c1e03f044 100644
--- a/usr/src/uts/common/io/cxgbe/t4nex/t4_sge.c
+++ b/usr/src/uts/common/io/cxgbe/t4nex/t4_sge.c
@@ -69,10 +69,6 @@ struct txinfo {
 	struct ulptx_sge_pair reserved[TX_SGL_SEGS / 2];
 };
 
-struct mblk_pair {
-	mblk_t *head, *tail;
-};
-
 struct rxbuf {
 	kmem_cache_t *cache;		/* the kmem_cache this rxb came from */
 	ddi_dma_handle_t dhdl;
@@ -84,24 +80,33 @@ struct rxbuf {
 	volatile uint_t ref_cnt;
 };
 
-static int service_iq(struct sge_iq *iq, int budget);
-static inline void init_iq(struct sge_iq *iq, struct adapter *sc, int tmr_idx,
-    int8_t pktc_idx, int qsize, uint8_t esize);
-static inline void init_fl(struct sge_fl *fl, uint16_t qsize);
-static int alloc_iq_fl(struct port_info *pi, struct sge_iq *iq,
-    struct sge_fl *fl, int intr_idx, int cong);
-static int free_iq_fl(struct port_info *pi, struct sge_iq *iq,
-    struct sge_fl *fl);
-static int alloc_rxq(struct port_info *pi, struct sge_rxq *rxq, int intr_idx,
-    int i);
-static int free_rxq(struct port_info *pi, struct sge_rxq *rxq);
-static int eth_eq_alloc(struct adapter *sc, struct port_info *pi,
-    struct sge_eq *eq);
-static int alloc_eq(struct adapter *sc, struct port_info *pi,
-    struct sge_eq *eq);
-static int free_eq(struct adapter *sc, struct sge_eq *eq);
-static int alloc_txq(struct port_info *pi, struct sge_txq *txq, int idx);
-static int free_txq(struct port_info *pi, struct sge_txq *txq);
+static const uint16_t t4_iq_esize_bytes[] = {
+	[T4_IQ_ESIZE_16B] = 16,
+	[T4_IQ_ESIZE_32B] = 32,
+	[T4_IQ_ESIZE_64B] = 64,
+	[T4_IQ_ESIZE_128B] = 128,
+};
+
+typedef struct t4_iq_params {
+	t4_iq_type_t	tip_iq_type;
+	uint8_t		tip_tmr_idx;
+	int8_t		tip_pktc_idx;
+	uint16_t	tip_qsize;
+	t4_iq_esize_t	tip_esize;
+	uint16_t	tip_fl_qsize;
+	int		tip_cong_chan;
+	t4_sge_iq_t	*tip_intr_evtq;
+	uint_t		tip_intr_idx;
+} t4_iq_params_t;
+
+static int t4_alloc_eq_base(struct port_info *, t4_sge_eq_t *);
+static void t4_free_iq(struct port_info *, t4_sge_iq_t *);
+static int t4_alloc_rxq(struct port_info *, struct sge_rxq *, uint_t);
+static void t4_free_rxq(struct port_info *, struct sge_rxq *);
+static void t4_free_eq(struct port_info *, t4_sge_eq_t *);
+static void t4_alloc_eq_post(struct port_info *, t4_sge_eq_t *);
+static int t4_alloc_txq(struct port_info *, struct sge_txq *, int);
+static void t4_free_txq(struct port_info *, struct sge_txq *);
 static int alloc_dma_memory(struct adapter *sc, size_t len, int flags,
     ddi_device_acc_attr_t *acc_attr, ddi_dma_attr_t *dma_attr,
     ddi_dma_handle_t *dma_hdl, ddi_acc_handle_t *acc_hdl, uint64_t *pba,
@@ -114,15 +119,14 @@ static int free_desc_ring(ddi_dma_handle_t *dhdl, ddi_acc_handle_t *ahdl);
 static int alloc_tx_copybuffer(struct adapter *sc, size_t len,
     ddi_dma_handle_t *dma_hdl, ddi_acc_handle_t *acc_hdl, uint64_t *pba,
     caddr_t *pva);
-static inline bool is_new_response(const struct sge_iq *iq,
-    struct rsp_ctrl **ctrl);
-static inline void iq_next(struct sge_iq *iq);
-static int refill_fl(struct adapter *sc, struct sge_fl *fl, int nbufs);
-static void refill_sfl(void *arg);
-static void add_fl_to_sfl(struct adapter *sc, struct sge_fl *fl);
-static void free_fl_bufs(struct sge_fl *fl);
-static mblk_t *get_fl_payload(struct adapter *sc, struct sge_fl *fl,
-    uint32_t len_newbuf, int *fl_bufs_used);
+static inline bool t4_get_new_rsp(const t4_sge_iq_t *, struct rsp_ctrl *);
+static inline void t4_iq_next_entry(t4_sge_iq_t *iq);
+static t4_iq_result_t t4_process_event_iq(t4_sge_iq_t *event_iq);
+static bool t4_fl_refill(struct sge_fl *, uint_t);
+static void t4_sfl_enqueue(struct adapter *, struct sge_fl *);
+static void t4_sfl_process(void *);
+static void t4_fl_free_bufs(struct sge_fl *fl);
+static mblk_t *t4_fl_get_payload(struct sge_fl *, uint32_t, bool);
 static int get_frame_txinfo(struct sge_txq *txq, mblk_t **fp,
     struct txinfo *txinfo, int sgl_only);
 static inline int fits_in_txb(struct sge_txq *txq, int len, int *waste);
@@ -140,29 +144,27 @@ static int write_txpkt_wr(struct port_info *pi, struct sge_txq *txq, mblk_t *m,
 static void t4_write_flush_wr(struct sge_txq *);
 static inline void write_ulp_cpl_sgl(struct port_info *pi, struct sge_txq *txq,
     struct txpkts *txpkts, struct txinfo *txinfo);
-static inline void copy_to_txd(struct sge_eq *eq, caddr_t from, caddr_t *to,
-    int len);
+static inline void copy_to_txd(t4_sge_eq_t *eq, caddr_t from, caddr_t *to,
+    size_t len);
 static void t4_tx_ring_db(struct sge_txq *);
-static uint_t t4_tx_reclaim_descs(struct sge_txq *, uint_t, mblk_t **);
-static int t4_eth_rx(struct sge_iq *iq, const struct rss_header *rss,
-    mblk_t *m);
-static inline void ring_fl_db(struct adapter *sc, struct sge_fl *fl);
+static uint16_t t4_tx_reclaim_credits(struct sge_txq *, uint16_t, mblk_t **);
+static void t4_fl_ring_db(struct sge_fl *fl);
 static kstat_t *setup_port_config_kstats(struct port_info *pi);
 static kstat_t *setup_port_info_kstats(struct port_info *pi);
 static kstat_t *setup_rxq_kstats(struct port_info *pi, struct sge_rxq *rxq,
-    int idx);
+    uint_t idx);
 static int update_rxq_kstats(kstat_t *ksp, int rw);
 static int update_port_info_kstats(kstat_t *ksp, int rw);
 static kstat_t *setup_txq_kstats(struct port_info *pi, struct sge_txq *txq,
     int idx);
 static int update_txq_kstats(kstat_t *ksp, int rw);
-static void t4_sge_egr_update(struct sge_iq *, const struct rss_header *);
-static int t4_handle_cpl_msg(struct sge_iq *, const struct rss_header *,
+static void t4_sge_egr_update(t4_sge_iq_t *, const struct rss_header *);
+static int t4_handle_cpl_msg(t4_sge_iq_t *, const struct rss_header *,
     mblk_t *);
-static int t4_handle_fw_msg(struct sge_iq *, const struct rss_header *);
+static int t4_handle_fw_msg(t4_sge_iq_t *, const struct rss_header *);
 
 static kmem_cache_t *rxbuf_cache_create(struct rxbuf_cache_params *);
-static struct rxbuf *rxbuf_alloc(kmem_cache_t *, int, uint_t);
+static struct rxbuf *rxbuf_alloc(kmem_cache_t *, int);
 static void rxbuf_free(struct rxbuf *);
 static int rxbuf_ctor(void *, void *, int);
 static void rxbuf_dtor(void *, void *);
@@ -173,34 +175,54 @@ t4_rss_payload(const struct rss_header *rss)
 	return ((void *)(&rss[1]));
 }
 
-static inline struct sge_iq **
+static inline t4_sge_iq_t **
 t4_iqmap_slot(struct adapter *sc, uint_t cntxt_id)
 {
-	const uint_t idx = cntxt_id - sc->sge.iq_start;
+	const uint_t idx = cntxt_id - sc->sge.iqmap_start;
 	VERIFY3U(idx, <, sc->sge.iqmap_sz);
 	return (&sc->sge.iqmap[idx]);
 }
 
-static inline struct sge_eq **
+static inline t4_sge_eq_t **
 t4_eqmap_slot(struct adapter *sc, uint_t cntxt_id)
 {
-	const uint_t idx = cntxt_id - sc->sge.eq_start;
+	const uint_t idx = cntxt_id - sc->sge.eqmap_start;
 	VERIFY3U(idx, <, sc->sge.eqmap_sz);
 	return (&sc->sge.eqmap[idx]);
 }
 
-static inline int
-reclaimable(struct sge_eq *eq)
+/*
+ * Get the address of the EQ host credit at the provided index.
+ */
+static inline void *
+t4_eq_credit(t4_sge_eq_t *eq, uint16_t idx)
 {
-	unsigned int cidx;
+	ASSERT3U(idx, <, eq->tse_qsize_spg);
+	uint8_t *credits = eq->tse_ring;
+	return (&credits[idx * EQ_HC_SIZE]);
+}
+
+static inline struct sge_rxq *
+t4_iq_to_rxq(t4_sge_iq_t *iq)
+{
+	if (iq->tsi_iqtype == TIQT_ETH_RX) {
+		return (__containerof(iq, struct sge_rxq, iq));
+	} else {
+		return (NULL);
+	}
+}
 
-	cidx = eq->spg->cidx;   /* stable snapshot */
-	cidx = be16_to_cpu(cidx);
+static inline t4_sge_iq_t *
+t4_fl_to_iq(struct sge_fl *fl)
+{
+	/*
+	 * Currently, RXQs are the only consumer of sge_fl, and are thus the
+	 * only case we need to worry about.
+	 */
+	struct sge_rxq *rxq = __containerof(fl, struct sge_rxq, fl);
+	ASSERT(rxq->iq.tsi_iqtype == TIQT_ETH_RX);
 
-	if (cidx >= eq->cidx)
-		return (cidx - eq->cidx);
-	else
-		return (cidx + eq->cap - eq->cidx);
+	return (&rxq->iq);
 }
 
 void
@@ -209,8 +231,7 @@ t4_sge_init(struct adapter *sc)
 	struct driver_properties *p = &sc->props;
 	ddi_dma_attr_t *dma_attr;
 	ddi_device_acc_attr_t *acc_attr;
-	uint32_t sge_control, sge_conm_ctrl;
-	int egress_threshold;
+	uint32_t sge_control;
 
 	/*
 	 * Device access and DMA attributes for descriptor rings
@@ -261,16 +282,25 @@ t4_sge_init(struct adapter *sc)
 	 */
 	sge_control = t4_read_reg(sc, A_SGE_CONTROL);
 	sc->sge.pktshift = G_PKTSHIFT(sge_control);
-	sc->sge.stat_len = (sge_control & F_EGRSTATUSPAGESIZE) ? 128 : 64;
+	sc->sge.eq_spg_len = (sge_control & F_EGRSTATUSPAGESIZE) ? 2 : 1;
 
 	/* t4_nex uses FLM packed mode */
-	sc->sge.fl_align = t4_fl_pkt_align(sc, true);
+	const int fl_align = t4_fl_pkt_align(sc, true);
+	VERIFY3S(fl_align, >=, 0);
+	/*
+	 * Minimum alignment for freelist buffer sizes is stated as 16, but in
+	 * order to keep bits [3:0] clear for identifying the buffer size
+	 * register, we use a minimum of 32.
+	 *
+	 * See A_SGE_FL_BUFFER_SIZE0 setting below.
+	 */
+	sc->sge.fl_align = MAX(fl_align, 32);
 
 	/*
-	 * Device access and DMA attributes for rx buffers
+	 * Device access and DMA attributes for RX buffers
 	 */
 	sc->sge.rxb_params.dip = sc->dip;
-	sc->sge.rxb_params.buf_size = rx_buf_size;
+	sc->sge.rxb_params.buf_size = P2ROUNDUP(rx_buf_size, fl_align);
 
 	acc_attr = &sc->sge.rxb_params.acc_attr_rx;
 	acc_attr->devacc_attr_version = DDI_DEVICE_ATTR_V0;
@@ -281,11 +311,6 @@ t4_sge_init(struct adapter *sc)
 	dma_attr->dma_attr_addr_lo = 0;
 	dma_attr->dma_attr_addr_hi = UINT64_MAX;
 	dma_attr->dma_attr_count_max = UINT64_MAX;
-	/*
-	 * Low 4 bits of an rx buffer address have a special meaning to the SGE
-	 * and an rx buf cannot have an address with any of these bits set.
-	 * FL_ALIGN is >= 32 so we're sure things are ok.
-	 */
 	dma_attr->dma_attr_align = sc->sge.fl_align;
 	dma_attr->dma_attr_burstsizes = 0xfff;
 	dma_attr->dma_attr_minxfer = 1;
@@ -298,7 +323,7 @@ t4_sge_init(struct adapter *sc)
 	sc->sge.rxbuf_cache = rxbuf_cache_create(&sc->sge.rxb_params);
 
 	/*
-	 * A FL with <= fl_starve_thres buffers is starving and a periodic
+	 * A FL with <= fl_starve_threshold buffers is starving and a periodic
 	 * timer will attempt to refill it.  This needs to be larger than the
 	 * SGE's Egress Congestion Threshold.  If it isn't, then we can get
 	 * stuck waiting for new packets while the SGE is waiting for us to
@@ -310,7 +335,8 @@ t4_sge_init(struct adapter *sc)
 	 * buffers.
 	 */
 
-	sge_conm_ctrl = t4_read_reg(sc, A_SGE_CONM_CTRL);
+	const uint32_t sge_conm_ctrl = t4_read_reg(sc, A_SGE_CONM_CTRL);
+	uint_t egress_threshold;
 	switch (CHELSIO_CHIP_VERSION(sc->params.chip)) {
 	case CHELSIO_T4:
 		egress_threshold = G_EGRTHRESHOLD(sge_conm_ctrl);
@@ -322,9 +348,20 @@ t4_sge_init(struct adapter *sc)
 	default:
 		egress_threshold = G_T6_EGRTHRESHOLDPACKING(sge_conm_ctrl);
 	}
-	sc->sge.fl_starve_threshold = 2*egress_threshold + 1;
+	sc->sge.fl_starve_threshold = 2 * egress_threshold + 1;
 
-	t4_write_reg(sc, A_SGE_FL_BUFFER_SIZE0, rx_buf_size);
+	/*
+	 * Set the size of buffers submitted through freelists.
+	 *
+	 * Strictly speaking, this is setting one of sixteen possible buffer
+	 * sizes, with bits [3:0] of freelist entries designating the size
+	 * register (0-15) which contains its corresponding size.
+	 *
+	 * Our driver does not currently make use of multiple sizes.  Submitted
+	 * buffers are at least 16-byte aligned, thus bits [3:0] are 0,
+	 * selecting this size register.
+	 */
+	t4_write_reg(sc, A_SGE_FL_BUFFER_SIZE0, sc->sge.rxb_params.buf_size);
 
 	t4_write_reg(sc, A_SGE_INGRESS_RX_THRESHOLD,
 	    V_THRESHOLD_0(p->holdoff_pktcnt[0]) |
@@ -343,201 +380,216 @@ t4_sge_init(struct adapter *sc)
 	    V_TIMERVALUE5(us_to_core_ticks(sc, p->holdoff_timer_us[5])));
 }
 
-static inline int
-first_vector(struct port_info *pi)
+static uint_t
+t4_queue_to_intrq(struct adapter *sc, uint_t q_idx)
 {
-	struct adapter *sc = pi->adapter;
-	int rc = T4_EXTRA_INTR, i;
-
-	if (sc->intr_count == 1)
-		return (0);
-
-	for_each_port(sc, i) {
-		struct port_info *p = sc->port[i];
-
-		if (i == pi->port_id)
-			break;
-
-		/*
-		 * Not compiled with offload support and intr_count > 1.  Only
-		 * NIC queues exist and they'd better be taking direct
-		 * interrupts.
-		 */
-		ASSERT(!(sc->flags & TAF_INTR_FWD));
-		rc += p->nrxq;
-	}
-	return (rc);
+	return (q_idx % sc->intr_queue_cfg.intr_per_port);
 }
 
 /*
- * Given an arbitrary "index," come up with an iq that can be used by other
- * queues (of this port) for interrupt forwarding, SGE egress updates, etc.
- * The iq returned is guaranteed to be something that takes direct interrupts.
+ * Assign an interrupt event queue to the Rx queue specified by q_idx. If
+ * we are in TIP_PER_PORT mode, this is done by multiplexing the Rx queues
+ * across the port's interrupt queues. Otherwise, all events are directed
+ * to the adapter-wide firmware queue.
  */
-static struct sge_iq *
-port_intr_iq(struct port_info *pi, int idx)
+static void
+t4_rxq_intr_assign(struct port_info *pi, uint_t rxq_idx,
+    struct t4_iq_params *iqp)
 {
 	struct adapter *sc = pi->adapter;
-	struct sge *s = &sc->sge;
-	struct sge_iq *iq = NULL;
+	const struct t4_intrs_queues *iqc = &sc->intr_queue_cfg;
 
-	if (sc->intr_count == 1)
-		return (&sc->sge.fwq);
+	switch (iqc->intr_plan) {
+	case TIP_PER_PORT: {
+		uint_t intr_iq_idx = t4_queue_to_intrq(sc, rxq_idx);
+		iqp->tip_intr_evtq = &pi->intr_iqs[intr_iq_idx];
+		iqp->tip_intr_idx = INTR_FORWARDED;
+		break;
+	}
+	case TIP_SINGLE:
+	case TIP_ERR_QUEUES:
+	default:
+		/* Forward all RXQ interrupts to FWQ */
+		iqp->tip_intr_evtq = &sc->sge.fwq;
+		iqp->tip_intr_idx = INTR_FORWARDED;
+		break;
+	}
+}
 
-	/*
-	 * Not compiled with offload support and intr_count > 1.  Only NIC
-	 * queues exist and they'd better be taking direct interrupts.
-	 */
-	ASSERT(!(sc->flags & TAF_INTR_FWD));
+void
+t4_port_kstats_init(struct port_info *pi)
+{
+	ASSERT(pi->ksp_config == NULL);
+	ASSERT(pi->ksp_info == NULL);
 
-	idx %= pi->nrxq;
-	iq = &s->rxq[pi->first_rxq + idx].iq;
+	pi->ksp_config = setup_port_config_kstats(pi);
+	pi->ksp_info = setup_port_info_kstats(pi);
+}
 
-	return (iq);
+void
+t4_port_kstats_fini(struct port_info *pi)
+{
+	if (pi->ksp_config != NULL) {
+		kstat_delete(pi->ksp_config);
+		pi->ksp_config = NULL;
+	}
+	if (pi->ksp_info != NULL) {
+		kstat_delete(pi->ksp_info);
+		pi->ksp_info = NULL;
+	}
 }
 
 int
-t4_setup_port_queues(struct port_info *pi)
+t4_port_queues_init(struct port_info *pi)
 {
-	int rc = 0, i, intr_idx, j;
-	struct sge_rxq *rxq;
-	struct sge_txq *txq;
+	int rc = 0;
+	uint_t q_idx;
 	struct adapter *sc = pi->adapter;
-	struct driver_properties *p = &sc->props;
 
-	pi->ksp_config = setup_port_config_kstats(pi);
-	pi->ksp_info   = setup_port_info_kstats(pi);
+	struct sge_rxq *rxq;
+	for_each_rxq(pi, q_idx, rxq) {
+		if ((rc = t4_alloc_rxq(pi, rxq, q_idx)) != 0) {
+			goto cleanup;
+		}
+	}
 
-	/* Interrupt vector to start from (when using multiple vectors) */
-	intr_idx = first_vector(pi);
+	struct sge_txq *txq;
+	for_each_txq(pi, q_idx, txq) {
+		txq->eq.tse_flags = 0;
+		txq->eq.tse_tx_chan = pi->tx_chan;
+		txq->eq.tse_qsize = sc->props.qsize_txq;
 
-	/*
-	 * First pass over all rx queues (NIC and TOE):
-	 * a) initialize iq and fl
-	 * b) allocate queue iff it will take direct interrupts.
-	 */
+		if (sc->intr_queue_cfg.intr_plan == TIP_PER_PORT) {
+			/*
+			 * If we have per port interrupts, then multiplex
+			 * TX completion events across them.
+			 */
+			uint_t intr_iq_idx = t4_queue_to_intrq(sc, q_idx);
+			txq->eq.tse_iqid =
+			    pi->intr_iqs[intr_iq_idx].tsi_cntxt_id;
+		} else {
+			/*
+			 * Otherwise, handle all TX completion events in
+			 * the firmware queue.
+			 */
+			txq->eq.tse_iqid = sc->sge.fwq.tsi_cntxt_id;
+		}
 
-	for_each_rxq(pi, i, rxq) {
+		if ((rc = t4_alloc_txq(pi, txq, q_idx)) != 0) {
+			goto cleanup;
+		}
+	}
 
-		init_iq(&rxq->iq, sc, pi->tmr_idx, pi->pktc_idx, p->qsize_rxq,
-		    RX_IQ_ESIZE);
+	return (0);
 
-		init_fl(&rxq->fl, p->qsize_rxq / 8); /* 8 bufs in each entry */
+cleanup:
+	t4_port_queues_fini(pi);
+	return (rc);
+}
 
-		if ((!(sc->flags & TAF_INTR_FWD)) ||
-		    (sc->intr_count > 1 && pi->nrxq)) {
-			rxq->iq.flags |= IQ_INTR;
-			rc = alloc_rxq(pi, rxq, intr_idx, i);
-			if (rc != 0)
-				goto done;
-			intr_idx++;
-		}
+void
+t4_port_queues_fini(struct port_info *pi)
+{
+	uint_t i;
 
+	struct sge_txq *txq;
+	for_each_txq(pi, i, txq) {
+		t4_free_txq(pi, txq);
 	}
 
-	/*
-	 * Second pass over all rx queues (NIC and TOE).  The queues forwarding
-	 * their interrupts are allocated now.
-	 */
-	j = 0;
+	struct sge_rxq *rxq;
 	for_each_rxq(pi, i, rxq) {
-		if (rxq->iq.flags & IQ_INTR)
-			continue;
+		t4_free_rxq(pi, rxq);
+	}
+}
 
-		intr_idx = port_intr_iq(pi, j)->abs_id;
+void
+t4_port_queues_enable(struct port_info *pi)
+{
+	ASSERT(pi->flags & TPF_INIT_DONE);
 
-		rc = alloc_rxq(pi, rxq, intr_idx, i);
-		if (rc != 0)
-			goto done;
-		j++;
-	}
+	uint_t i;
+	struct adapter *sc = pi->adapter;
+	struct sge_rxq *rxq;
 
-	/*
-	 * Now the tx queues.  Only one pass needed.
-	 */
-	j = 0;
-	for_each_txq(pi, i, txq) {
-		txq->eq.flags = 0;
-		txq->eq.tx_chan = pi->tx_chan;
-		txq->eq.qsize = p->qsize_txq;
+	mutex_enter(&sc->sfl_lock);
+	for_each_rxq(pi, i, rxq) {
+		t4_sge_iq_t *iq = &rxq->iq;
 
-		/* For now, direct all TX queue notifications to the FW IQ. */
-		txq->eq.iqid = sc->sge.fwq.cntxt_id;
+		IQ_LOCK(iq);
+		VERIFY0(iq->tsi_flags & IQ_ENABLED);
+		iq->tsi_flags |= IQ_ENABLED;
+
+		/*
+		 * Freelists which were marked "doomed" by a previous
+		 * t4_port_queues_disable() call should clear that status.
+		 */
+		rxq->fl.sfl_flags &= ~SFL_DOOMED;
 
-		rc = alloc_txq(pi, txq, i);
-		if (rc != 0)
-			goto done;
+		t4_iq_gts_update(iq, iq->tsi_gts_rearm, 0);
+		IQ_UNLOCK(iq);
 	}
+	mutex_exit(&sc->sfl_lock);
 
-done:
-	if (rc != 0)
-		(void) t4_teardown_port_queues(pi);
+	struct sge_txq *txq;
+	for_each_txq(pi, i, txq) {
+		t4_sge_eq_t *eq = &txq->eq;
 
-	return (rc);
+		EQ_LOCK(eq);
+		eq->tse_flags |= EQ_ENABLED;
+		EQ_UNLOCK(eq);
+	}
 }
 
-/*
- * Idempotent
- */
-int
-t4_teardown_port_queues(struct port_info *pi)
+void
+t4_port_queues_disable(struct port_info *pi)
 {
-	int i;
+	uint_t i;
+	struct adapter *sc = pi->adapter;
 	struct sge_rxq *rxq;
-	struct sge_txq *txq;
-
-	if (pi->ksp_config != NULL) {
-		kstat_delete(pi->ksp_config);
-		pi->ksp_config = NULL;
-	}
-	if (pi->ksp_info != NULL) {
-		kstat_delete(pi->ksp_info);
-		pi->ksp_info = NULL;
-	}
 
-	for_each_txq(pi, i, txq) {
-		(void) free_txq(pi, txq);
-	}
+	ASSERT(pi->flags & TPF_INIT_DONE);
 
 	for_each_rxq(pi, i, rxq) {
-		if ((rxq->iq.flags & IQ_INTR) == 0)
-			(void) free_rxq(pi, rxq);
-	}
+		t4_sge_iq_t *iq = &rxq->iq;
 
-	/*
-	 * Then take down the rx queues that take direct interrupts.
-	 */
+		IQ_LOCK(iq);
+		iq->tsi_flags &= ~IQ_ENABLED;
+		IQ_UNLOCK(iq);
+	}
 
+	mutex_enter(&sc->sfl_lock);
 	for_each_rxq(pi, i, rxq) {
-		if (rxq->iq.flags & IQ_INTR)
-			(void) free_rxq(pi, rxq);
+		rxq->fl.sfl_flags |= SFL_DOOMED;
 	}
+	mutex_exit(&sc->sfl_lock);
+	/* TODO: need to wait for all fl's to be removed from sc->sfl */
 
-	return (0);
-}
-
-/* Deals with errors and forwarded interrupts */
-uint_t
-t4_intr_all(caddr_t arg1, caddr_t arg2)
-{
-
-	(void) t4_intr_err(arg1, arg2);
-	(void) t4_intr(arg1, arg2);
+	struct sge_txq *txq;
+	for_each_txq(pi, i, txq) {
+		t4_sge_eq_t *eq = &txq->eq;
 
-	return (DDI_INTR_CLAIMED);
+		EQ_LOCK(eq);
+		eq->tse_flags &= ~EQ_ENABLED;
+		EQ_UNLOCK(eq);
+	}
+	/*
+	 * TODO: issue flush WR to EQs and wait for EGR update to ensure that
+	 * all processing has completed.
+	 */
 }
 
 /*
- * We are counting on the values of t4_intr_config_t matching the register
+ * We are counting on the values of t4_gts_config_t matching the register
  * definitions from the shared code.
  */
-CTASSERT(TIC_SE_INTR_ARM == F_QINTR_CNT_EN);
-CTASSERT(TIC_TIMER0 == V_QINTR_TIMER_IDX(X_TIMERREG_COUNTER0));
-CTASSERT(TIC_TIMER5 == V_QINTR_TIMER_IDX(X_TIMERREG_COUNTER5));
-CTASSERT(TIC_START_COUNTER == V_QINTR_TIMER_IDX(X_TIMERREG_RESTART_COUNTER));
+CTASSERT(TGC_SE_INTR_ARM == F_QINTR_CNT_EN);
+CTASSERT(TGC_TIMER0 == V_QINTR_TIMER_IDX(X_TIMERREG_COUNTER0));
+CTASSERT(TGC_TIMER5 == V_QINTR_TIMER_IDX(X_TIMERREG_COUNTER5));
+CTASSERT(TGC_START_COUNTER == V_QINTR_TIMER_IDX(X_TIMERREG_RESTART_COUNTER));
 
 void
-t4_iq_update_intr_cfg(struct sge_iq *iq, uint8_t tmr_idx, int8_t pktc_idx)
+t4_iq_update_intr_cfg(t4_sge_iq_t *iq, uint8_t tmr_idx, int8_t pktc_idx)
 {
 	ASSERT((pktc_idx >= 0 && pktc_idx < SGE_NCOUNTERS) || pktc_idx == -1);
 	IQ_LOCK_ASSERT_OWNED(iq);
@@ -550,37 +602,37 @@ t4_iq_update_intr_cfg(struct sge_iq *iq, uint8_t tmr_idx, int8_t pktc_idx)
 	 */
 	ASSERT3U(tmr_idx, <, SGE_NTIMERS);
 
-	iq->intr_params = V_QINTR_TIMER_IDX(tmr_idx) |
-	    ((pktc_idx != -1) ? TIC_SE_INTR_ARM : 0);
+	iq->tsi_gts_rearm = V_QINTR_TIMER_IDX(tmr_idx) |
+	    ((pktc_idx != -1) ? TGC_SE_INTR_ARM : 0);
 
 	/* Update IQ for new packet count threshold, but only if enabled */
-	if (pktc_idx != iq->intr_pktc_idx && pktc_idx >= 0) {
+	if (pktc_idx != iq->tsi_intr_pktc_idx && pktc_idx >= 0) {
 		const uint32_t param = V_FW_PARAMS_MNEM(FW_PARAMS_MNEM_DMAQ) |
 		    V_FW_PARAMS_PARAM_X(FW_PARAMS_PARAM_DMAQ_IQ_INTCNTTHRESH) |
-		    V_FW_PARAMS_PARAM_YZ(iq->cntxt_id);
+		    V_FW_PARAMS_PARAM_YZ(iq->tsi_cntxt_id);
 		const uint32_t val = pktc_idx;
 
-		struct adapter *sc = iq->adapter;
+		struct adapter *sc = iq->tsi_adapter;
 		int rc =
 		    -t4_set_params(sc, sc->mbox, sc->pf, 0, 1, &param, &val);
 		if (rc != 0) {
 			/* report error but carry on */
 			cxgb_printf(sc->dip, CE_WARN,
 			    "failed to set intr pktcnt index for IQ %d: %d",
-			    iq->cntxt_id, rc);
+			    iq->tsi_cntxt_id, rc);
 		}
 	}
-	iq->intr_pktc_idx = pktc_idx;
+	iq->tsi_intr_pktc_idx = pktc_idx;
 }
 
 void
-t4_eq_update_dbq_timer(struct sge_eq *eq, struct port_info *pi)
+t4_eq_update_dbq_timer(t4_sge_eq_t *eq, struct port_info *pi)
 {
 	struct adapter *sc = pi->adapter;
 
 	const uint32_t param = V_FW_PARAMS_MNEM(FW_PARAMS_MNEM_DMAQ) |
 	    V_FW_PARAMS_PARAM_X(FW_PARAMS_PARAM_DMAQ_EQ_TIMERIX) |
-	    V_FW_PARAMS_PARAM_YZ(eq->cntxt_id);
+	    V_FW_PARAMS_PARAM_YZ(eq->tse_cntxt_id);
 	const uint32_t val = pi->dbq_timer_idx;
 
 	int rc = -t4_set_params(sc, sc->mbox, sc->pf, 0, 1, &param, &val);
@@ -588,7 +640,7 @@ t4_eq_update_dbq_timer(struct sge_eq *eq, struct port_info *pi)
 		/* report error but carry on */
 		cxgb_printf(sc->dip, CE_WARN,
 		    "failed to set DBQ timer index for EQ %d: %d",
-		    eq->cntxt_id, rc);
+		    eq->tse_cntxt_id, rc);
 	}
 }
 
@@ -597,13 +649,13 @@ t4_eq_update_dbq_timer(struct sge_eq *eq, struct port_info *pi)
  * ingress queue.
  */
 void
-t4_iq_gts_update(struct sge_iq *iq, t4_intr_config_t cfg, uint16_t cidx_incr)
+t4_iq_gts_update(t4_sge_iq_t *iq, t4_gts_config_t cfg, uint16_t cidx_incr)
 {
 	const uint32_t value =
-	    V_INGRESSQID((uint32_t)iq->cntxt_id) |
+	    V_INGRESSQID((uint32_t)iq->tsi_cntxt_id) |
 	    V_CIDXINC((uint32_t)cidx_incr) |
 	    V_SEINTARM((uint32_t)cfg);
-	t4_write_reg(iq->adapter, MYPF_REG(A_SGE_PF_GTS), value);
+	t4_write_reg(iq->tsi_adapter, MYPF_REG(A_SGE_PF_GTS), value);
 }
 
 /*
